<?php
////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                        //
// M Shaw - Author - 2009 - See http://microapache.amadis.sytes.net for free webserver                    //
// V1.00 31/07/2009 - First version. Generates XML file and loads INDEX page                              // 
//                                                                                                        //
////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                        //
// MP3 Player (Win32) - XML Auto-generating INDEX.PHP code for PremiumBeat (TM) MP3 Streamer              //
// The PremiumBeat objects should be in folder called (root)/player/ (see below)                          //
// This file must be copied to every folder where you want a jukebox player to appear                     //
// Download the SWF-based player FREE from:                                                               //
// http://www.premiumbeat.com/flash_resources/free_flash_music_player/                                    //
// The recommended player is located at URL:                                                              //
// http://www.premiumbeat.com/flash_resources/free_flash_music_player/multiple_tracks_mp3_player_menu.php //
//                                                                                                        //
// Note: Player does not like files with "&%'#" in the filename                                           //
//       The filetype (.mp3) is not shown in the title list                                               //
//       The player is "non-scrubbing" - files in say Seamonkey will be stored locally in:                //
//         \Documents and Settings\<user>\Local Settings\Application Data\Mozilla\Profiles\default\Cache  //
//       You may obfuscate your MP3s POSTfixing "-_()" in filenames to prevent direct downloading         //
//                                                                                                        //
////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Install instructions (Win32):                                                                          //
//                                                                                                        //
// Download the FREE SWF-based MP3 player from the URL above. Note the EULA and that this is FREEWARE     //
// Create DOCUMENT root folders "\player\" and \player\wallpapers\"                                       //
// N.B. For MicroApache this will be the root of your USB (or other) device unless you change httpd.conf  //
// Change this if you want by editing "DocumentRoot /" in httpd.conf if you're using Apache webserver     //
// Copy this file (index.php) and transparent nav-button, tsp_button.png into your new "\player\" folder  //
// Copy the PremiumBeat files: playerMultipleList.swf and swfobject.js to "\player\"                      //
// Copy your wallpaper selection to "\player\wallpapers\"  (*optional*)                                   //
// Create a folder to hold your MP3 collection *anywhere*, e,g, "<server root>\jukebox\"                  //
// Copy populate-folders.bat to the folder above                                                          //
// Copy DOSTREE.EXE to the root folder and, if nesc edit populate-tree.bat to reflect this location       //
// Run populate-folders.bat to populate all subfolders with the "\player\INDEX.PHP" file (or do manually) //
// That's it. Start your server (e.g. MicroApache) and browse to your "Jukebox" folder and browse folders //
// containing your MP3 files. Your MP3 player should load for each folder and wallpaper be randomly set   //
// Enjoy!                                                                                                 //
//                                                                                                        //
////////////////////////////////////////////////////////////////////////////////////////////////////////////




// Function library for PHP 4 support ///////////////////////////////////////////
if(floatval(phpversion())<5)
{
   function stripos($haystack,$needle)
   {
      $retval=false;
      for($i=0; $i<= strlen($haystack); $i++)
      {
          if(strtolower(substr($haystack,$i,strlen($needle))) == strtolower($needle))
          {
              $retval = true;
              break;
          }
      }
      return $retval;
   }
}

if(floatval(phpversion())<5)
{
   function strripos($haystack, $needle) 
   {
      $iter = stripos($haystack, $needle);
      $pos = -1;
      while ($iter !== false) 
      {
          $pos = $iter + ($pos+1);
          $iter = stripos(substr($haystack,$pos+1), $needle);
      }
      return ($pos != -1) ? $pos : false;
   }
}

/////////////////////////////////////////////////////////////////////////////////

// MAIN /////////////////////////////////////////////////////////////////////////
// WARNING: You MUST enable:
// AcceptPathInfo On
// in your conf\httpd.conf file otherwise $_SERVER['PATH_TRANSLATED'] will be blank!
// Ummm... the code as modified to be more "compliant" seems buggy and unreliable

   //$debug=true;	                // Debug mode
   $outfile="playlist.xml";
   $path_translated = stripslashes($_SERVER['PATH_TRANSLATED']);  // Try for the correct path...
   if($path_translated=="") // PHP bug not setting PATH_TRANSLATED even when AcceptPathInfo is set ON
   {             // Sheesh - thanks to PHP 5+ we have to resort to an ugly hack to adhere to CGI spec!
     $path_translated=stripslashes($_SERVER['SCRIPT_FILENAME']);  // Gives x:/dir/scriptname.php
   }

   $path=$path_translated;
   if($debug) echo "RAW Path [".$path."]<br>\n";// DEBUG
   $path=str_replace("\'","'",$path);	// Replace any escaped single quotes
   $path=str_replace("/","\\",$path);

   if($debug) echo "Path [".$path."]<br>\n";// DEBUG
   
   $p=strrpos($path,"\\");
   if($p>0)
   {
      if($debug) 
      {
         echo "p=".$p."]<br>\n";// DEBUG
         echo "substr [".substr($path,$p)."]<br>\n";
         echo "substr [".substr($path,0,$p)."]<br>\n";
      }
      //string substr  ( string $string  , int $start  [, int $length  ] )
      $path=substr($path,0,$p);
   }


   if($debug) echo "Opening path [".$path."]<br>\n";// DEBUG

   // Build up the file list for this directory - we search for matching files only
   $dh = @opendir($path);
   while (false !== ($file=readdir($dh)))
   {
      // echo "->$file<br>\n";	// DEBUG
      if (substr($file,0,1)!=".")	// If not a DIR entry
      {
	//if(strripos($file,".mp3") ||strripos($file,".mp4") ) // PHP 5+
         if(strripos($file,".mp3"))
         {
	    $files[]=array($file);   //#1-D array
         // $files[]=array(filemtime($path.$file),$file);   #2-D array
         }
      }
   }
   closedir($dh);


   // SORT AND WRITE OUT XML FILE ///////////////////////////////////////////////

   if ($files)
   {
      $f=fopen($outfile,"wb");
      if(!$f)
         die("Can't open or create MP3 list configuration file - $outfile<br>\n");
      else
      {
         fwrite($f,'<?xml version="1.0" encoding="UTF-8"?>'."\r\n<xml>\r\n");

         //rsort($files); #sorts by filemtime reverse
	 sort($files); #sorts by filemtime normal
     
         foreach ($files as $file)
         {
            //echo "$file[0]<br>\n";  //#file[0]=Unix timestamp; file[1]=filename
           fwrite($f,"<track>\r\n\t<path>".str_replace("'","&apos;",$file[0])."</path>\r\n");
           $title=str_replace("'","&apos;",$file[0]);
           $title=substr($title,0,strpos($title,".mp3"));
           $title=trim($title,"#-_()");			// Strip non-alpha prefix characters FIRST
           $title=str_replace("_"," ",$title);          // Remove embedded underscores from the title
//           $title=str_replace("-"," ",$title);	// remove embedded - signs (probably not a good idea)

           //$title=str_replace("#"," ",$title);        // remove protection character(s)
            
           $title=ucwords($title);	                // Ensure neat and tidy initcaps
      
           fwrite($f,"\t<title>$title</title>\r\n");
           fwrite($f,"</track>\r\n");
         }
	 fwrite($f,"\r\n</xml>");
	 fclose($f);
         unset($files);	// Empty the array as we wil reuse it
      }
   } 
   else
   {
     die( "<center><h2><b>Sorry, no MP3 files found in this folder</b></h2></center>\n");
   }


// HTML INDEX PAGE CONTENTS FOLLOW AFTER THIS POINT /////////////////////////////

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<?  // A brief bit of PHP to set the HEAD Title value //////////////////////////
   $uri=stripslashes($_SERVER['REQUEST_URI']);
   $uri=str_replace("%20"," ",$uri);
   //$uri=strip_tags($uri);
   //$uri=preg_replace('%20',"+",$uri);
   echo "<title>Jukebox Player for MP3s in: ".$uri."</title>\r\n";
?>
</head>

<? // WALLPAPER /// Use random JPG file as wallpaper ////////////////////////////
   // This is a kludge as we will be placing our wallpapers off a root folder on an
   // unknown drive letter which, depending on DOCUMENT_ROOT may be outside the doc root
   $docroot=$_SERVER['DOCUMENT_ROOT'];
   if($debug) echo "DOCUMENT_ROOT is [$docroot]<br>\n";
   $wproot=substr($docroot,0,2)."/player/wallpapers/"; // Look in special folder
   if($debug) echo "wallpaper ROOT is [$wproot]<br>\n";
   $dh = @opendir($wproot);
   $background="";
   $count=0;
   while (($file=readdir($dh)) !== false )
   {
      // echo "->$file<br>\n";	// DEBUG
      if (substr($file,0,1)!=".")	// If not a DIR entry
      {
         if(strripos($file,".jpg"))
         {
           //echo "Found file [$file]<br>\n";
	    $files[]=$file;   // #1D array
            $count++;
            //break;                 // Uncomment to select 1st file
         }
      }
   }
   closedir($dh);

   $r=rand(0,$count-1);		// Pick an index in this list at random
   $background=$files[$r];	// Select random wallpaper
   //echo "Count is $count and r is $r [".$files[$r]."]<br>\n";
   //echo "files [".print_r($files)."]<br>";

   echo '<body bgcolor="#000000"';
   if($background!="")
   {   
      $background="/player/wallpapers/".$background;
      echo ' background="'.$background.'"';
   }
   echo ">"
?>
<a href=".."><img src="/player/tsp_button.png" alt="UP Button" border="0" title="Go back up one level"></a>

<!-- Begin Copy/Paste -->
<p align="center"><script type="text/javascript" src="/player/swfobject.js"></script> </p>
<!-- x -->

<div align="center"><center>

<table border="0">
  <tr>
    <td align="center"><div id="flashPlayer">
      <p>This text will be replaced by the flash music player.</p>
    </div></td>
  </tr>
</table>
</center></div>

<p>
<script type="text/javascript">
   var so = new SWFObject("/player/playerMultipleList.swf", "mymovie", "295", "200", "7", "#FFFFFF");  
   so.addVariable("autoPlay","yes")
   so.addVariable("playlistPath","playlist.xml")
   so.addVariable("overColor","#990099")
   so.addVariable("playerSkin","1")
   so.write("flashPlayer");
</script> <!-- End Copy/Paste --> 
</p>

</body>
</html>

